/*  $RCSfile: quicksort.c,v $ */
/*  $Author: nakane $ */
/*  $Date: 2000/07/03 02:46:05 $ */
/*  $Revision: 1.2 $ */
/*  $State: Exp $ */

#include <stdio.h>

/*  #define MAX_NUM 2 */

void quicksort(int a[], int first, int last);
void dump_data(int *base, size_t number);

int main(int argc, char **argv) {
/*    int source_data[MAX_NUM]; */
  int source_data[] = { 5, 25, 20, 14, 2, 39, 9, 8 } ;
/*    int index; */
  
/*    for ( index = 0 ; index < MAX_NUM ; ++index ) { */
/*        source_data[index] = MAX_NUM - index;  */
/*        source_data[index] = index;  */
/*      source_data[index] = 20; */
/*    } */
/*    source_data[MAX_NUM-1] = 4; */
  quicksort(source_data, 0, 7);
  dump_data(source_data, 8);
  return 0;
}

void quicksort(int a[], int first, int last) {
  int i,j,pevot,tmp;
  pevot = a[(first+last)/2];
  i = first, j = last;
  while (1) {
    while ( a[i]  < pevot   ) ++i;
    while ( pevot < a[j]    ) --j;
    if ( i >= j ) break;
    tmp  = a[i];
    a[i] = a[j];
    a[j] = tmp ;
    ++i;
    --j;
  }
  if ( first < i-1 ) quicksort(a, first, i-1 );
  if ( j+1   < last) quicksort(a, j+1  , last);
}

void dump_data(int *base, size_t number) {
  int index;

  for ( index = 0 ; index < number ; ++index ) {
    printf("%d ", *base);
    ++base;
  }
  printf("\n");
}
